<?php
//******************************************************************************
//                       CLASSES REQUIRED TO MAIL THE PDF
//******************************************************************************
require_once('include.constants.php');
/* Is required in the mainscript via require_once, to allow single execution and
   compilation, require_once here again.
*/
require_once('class.phpmailer.php');

class bm_emailer extends PHPMailer
{
	//Redefine some variables to preset sender/mail information
	//Now the script is set to SMTP.
	var $From     = BM_TXT_EMAIL_FROM_ADDRESS;
  var $FromName = BM_TXT_EMAIL_FROM_NAME;
	//Required for SMTP START
	var $Host     = "smtp.xyz.xyz"; 
	var $SMTPAuth = true;     // turn on SMTP authentication
	var $Username = "foo.bar";  // SMTP username
	var $Password = "foo.password.bar"; // SMTP password 
	var $Mailer   = "smtp";                         // Alternative to IsSMTP()
	//Required for SMTP END
	var $WordWrap = 75;  
		
	function bm_emailer()
	{
		//import input email-adress from global scope
		global $bm_in_email;
		//Code
		$aux=new auxtools();
		$this->Subject=BM_TXT_EMAIL_SUBJECT;
		$this->Body=$this->prepare_body_html(); //Load from file and replace placeholders
		$this->AltBody=$this->prepare_body_text(); //Dito
		//If email-adress valid continue, else exit the script.
		if ($this->email_validate($bm_in_email))
		{
			$this->AddAddress($bm_in_email);
		} else {
			$aux->error(BM_OUT_EMAILWRONG);
		}
		/* Uncomment the following line and comment the lines at required for SMTP to send via localhost mail agent.*/
		//$this->IsMail();
	}//END bm_emailer
	
	/* send_email
		 Sends the email with all given settings and releases the PDF-File.		 
		 * PARAMETER *
		 &$pdf_handle : Reference to the PDF-Handler the PDF was created with. Required to release the PDF
		 		    via releaseoutput.
		 * RETURNS * 
		 int BM_OUT	  : Returns a number representing a BM_OUT_ Const, normally it should be BM_OUT_OK
		 		    This number can be printed by the mainscript.
	*/
	function send_email(&$pdf_handle)
	{
		//Send
		if($this->Send())
    		{
       		echo BM_OUT_OK;
		}
    		else
    		{
       		echo BM_OUT_MAIL_SEND_FAILED;
       		echo " ".$this->ErrorInfo;
    		}
		/* 
		   Actually not needed anylonger, since the PDF ist transferred as string not as reference to a file.
		   Kept until transfer via file is completly out of business.
		*/
		$pdf_handle->releaseoutput();	
	}
	
	/* putattachment
	   Adds the attachment to the email and sets the correct MIME-Type for the attachment (application/pdf)
	   The attachments is handed in from the PDF-Handler as String, so there is no need for temporary storage or
	   releaseoutput.
	   For further improvements like a online menstruation history or user accounts, saving the pdfs as string in
	   a database could be some idea. 
	   * PARAMETER *
	   $pdf_handle	 : Handle to the bm_pdf that created the pdf. Required for access to the pdf_output.
	*/
	function putattachment($pdf_handle)
	{
		$this->AddStringAttachment($pdf_handle->pdf_output,BM_TXT_EMAIL_ATTACHMENT_FILENAME,'base64','application/pdf');
	}//END putattachment
	
	// /* prepare_body_html
	// Gets a template for the HTML-Body with placeholders from a file and fills in the placeholders.
	// */
	
	function prepare_body_html()
	{
		$filecontents=file_get_contents(BM_TEMPLATE_EMAIL_BODY_HTML,1);
		$templatefertig=$this->replace_template($filecontents);
		return $templatefertig;	
	}//END prepare_html_body
	
	/* prepare_body_text
	Gets a template for the Text-Body with placeholders from a file and fills in the placeholders.
	*/
	function prepare_body_text()
	{
		$filecontents=file_get_contents(BM_TEMPLATE_EMAIL_BODY_TEXT,1);
		$templatefertig=$this->replace_template($filecontents);
		return $templatefertig;
	}//END prepare_html_body

//------------------------------------------------------------------------------
//                    ADDITIONAL AND HELPER FUNCTIONS
//------------------------------------------------------------------------------
	//Validates if a given email-adress is valid regarding only the syntax.
	function validate_syntax($email)
	{
		// Create the syntactical validation regular expression
     		$regexp = "^([_a-z0-9-]+)(\.[_a-z0-9-]+)*@([a-z0-9-]+)(\.[a-z0-9-]+)*(\.[a-z]{2,4})$";
   		// Presume that the email is invalid
   		$valid = 0;
   		// Validate the syntax
   		$valid=eregi($regexp, $email);
		return $valid;
	}//END validate_syntax

	//Vailidates if the server of a given email-adress gives a vaild adress back.
	function validate_server($email)
	{
		// Create the syntactical validation regular expression
	    	$regexp = "^([_a-z0-9-]+)(\.[_a-z0-9-]+)*@([a-z0-9-]+)(\.[a-z0-9-]+)*(\.[a-z]{2,4})$";
   		// Presume that the email is invalid
	  	$valid = 0;
	  	// Validate the syntax
	   	if (eregi($regexp, $email))
     		{
		      list($username,$domaintld) = split("@",$email);
        		// Validate the domain
	        	if (getmxrr($domaintld,$mxrecords))
			{
				$valid = 1;
     			} else {
	        		$valid = 0;
      	  	}
     		}
     		return $valid;
     	}//END validate_server
	
	
	/* email_validate
	Validates an email-adress.
	On Unix it validates the the domains email servers response as well, on windows it just validates the syntax.
	*/
	function email_validate($emailaddress)
	{
		
		//MAIN CODE
		$aux=new auxtools;
		if ($aux->iswindows())
		{
			/* If testing with an address like bla@localhost , validate_syntax will always return false.
			   In this case leave the return true in this place. If you test with a correct email-adress
			   uncomment the following line and comment return true.
			*/
			//return $this->validate_syntax($emailaddress);
			return true;
		} else {
			return ($this->validate_syntax($emailaddress) AND $this->validate_server($emailaddress));
		}
	}
	
	/* replacetemplate
	Replaces the placeholders in a template	
	* PARAMETER *
	string $template String with the contents of the template
	* RETURNS *
	string The processed and filled template.
	*/
	function replace_template($template)
	{
		//Import Globals
  		global $bm_in_monat;
	  	global $bm_in_jahr;
  		global $bm_in_name;
	  	global $bm_in_email;
	  	//Params to search for in template via str_replace
  		$search=array('$bm_in_monat','$bm_in_jahr','$bm_in_name','$bm_in_email');
		//Convert to Globals to Array as Replace for str_replace
		$replace=array($bm_in_monat,$bm_in_jahr,$bm_in_name,$bm_in_email);
		
		return str_replace($search,$replace,$template);
	}//END replace_template
	
}//END class bm_emailer

//### DEBUG ###
//$deb=new auxtools();
//$backtrace=debug_backtrace();
//$deb->debug_out(__FILE__.' OK<br>'.'(in '.__FILE__.', Line: '.__LINE__.', Function: '.__FUNCTION__.')<br>');
?>